// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from g29_msg:msg/G29Msg.idl
// generated code does not contain a copyright notice

#ifndef G29_MSG__MSG__DETAIL__G29_MSG__FUNCTIONS_H_
#define G29_MSG__MSG__DETAIL__G29_MSG__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "g29_msg/msg/rosidl_generator_c__visibility_control.h"

#include "g29_msg/msg/detail/g29_msg__struct.h"

/// Initialize msg/G29Msg message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * g29_msg__msg__G29Msg
 * )) before or use
 * g29_msg__msg__G29Msg__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_g29_msg
bool
g29_msg__msg__G29Msg__init(g29_msg__msg__G29Msg * msg);

/// Finalize msg/G29Msg message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_g29_msg
void
g29_msg__msg__G29Msg__fini(g29_msg__msg__G29Msg * msg);

/// Create msg/G29Msg message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * g29_msg__msg__G29Msg__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_g29_msg
g29_msg__msg__G29Msg *
g29_msg__msg__G29Msg__create();

/// Destroy msg/G29Msg message.
/**
 * It calls
 * g29_msg__msg__G29Msg__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_g29_msg
void
g29_msg__msg__G29Msg__destroy(g29_msg__msg__G29Msg * msg);

/// Check for msg/G29Msg message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_g29_msg
bool
g29_msg__msg__G29Msg__are_equal(const g29_msg__msg__G29Msg * lhs, const g29_msg__msg__G29Msg * rhs);

/// Copy a msg/G29Msg message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_g29_msg
bool
g29_msg__msg__G29Msg__copy(
  const g29_msg__msg__G29Msg * input,
  g29_msg__msg__G29Msg * output);

/// Initialize array of msg/G29Msg messages.
/**
 * It allocates the memory for the number of elements and calls
 * g29_msg__msg__G29Msg__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_g29_msg
bool
g29_msg__msg__G29Msg__Sequence__init(g29_msg__msg__G29Msg__Sequence * array, size_t size);

/// Finalize array of msg/G29Msg messages.
/**
 * It calls
 * g29_msg__msg__G29Msg__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_g29_msg
void
g29_msg__msg__G29Msg__Sequence__fini(g29_msg__msg__G29Msg__Sequence * array);

/// Create array of msg/G29Msg messages.
/**
 * It allocates the memory for the array and calls
 * g29_msg__msg__G29Msg__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_g29_msg
g29_msg__msg__G29Msg__Sequence *
g29_msg__msg__G29Msg__Sequence__create(size_t size);

/// Destroy array of msg/G29Msg messages.
/**
 * It calls
 * g29_msg__msg__G29Msg__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_g29_msg
void
g29_msg__msg__G29Msg__Sequence__destroy(g29_msg__msg__G29Msg__Sequence * array);

/// Check for msg/G29Msg message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_g29_msg
bool
g29_msg__msg__G29Msg__Sequence__are_equal(const g29_msg__msg__G29Msg__Sequence * lhs, const g29_msg__msg__G29Msg__Sequence * rhs);

/// Copy an array of msg/G29Msg messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_g29_msg
bool
g29_msg__msg__G29Msg__Sequence__copy(
  const g29_msg__msg__G29Msg__Sequence * input,
  g29_msg__msg__G29Msg__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // G29_MSG__MSG__DETAIL__G29_MSG__FUNCTIONS_H_
